<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Mapping Subtrees</TITLE>
<link href="suif1_22.html" rel=Next>
<link href="suif1_20.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_20.html">previous</A>, <A HREF="suif1_22.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC21" HREF="suif1_toc.html#TOC21">Mapping Functions Over Subtrees</A></H2>
<P>
<A NAME="IDX128"></A>

</P>
<P>
<A NAME="IDX129"></A>
<A NAME="IDX130"></A>
Many SUIF programs contain code that visits all of the nodes in an AST
to perform various operations.  Rather than having every programmer
duplicate the code for this traversal, the SUIF library includes methods
to map functions over ASTs.  The <CODE>tree_node</CODE> and
<CODE>tree_node_list</CODE> classes both provide these <CODE>map</CODE> methods.

</P>
<P>
The function to be mapped must be of type <CODE>tree_map_f</CODE>.  For a tree
node, the <CODE>map</CODE> method applies the function to the tree node and
all of its children.  The <CODE>preorder</CODE> parameter is used to select
either preorder or postorder traversals; the default is preorder.  For
preorder traversals, the function is applied to the tree node before it
is applied to the children.  For postorder, the function is first
applied to the tree_node's children and descendants and then last
applied to the tree node itself.

</P>
<P>
The <CODE>map</CODE> method for a tree node list calls <CODE>map</CODE> for each
node in the list.  The nodes are visited in order from first to last
regardless of the <CODE>preorder</CODE> parameter.  The <CODE>tree_node_list</CODE>
version of the <CODE>map</CODE> method has an extra optional parameter that
allows you to only map the function over the entries in the list without
recursively visiting their children.

</P>
<P>
The <CODE>tree_map_f</CODE> functions have two parameters: a pointer to the
tree node and a <CODE>void*</CODE> value passed on from the <CODE>map</CODE> method.
Additional parameters can be passed by making the <CODE>void*</CODE> value a
pointer to a structure containing the parameters.  For example, the
following code counts the number of <CODE>tree_for</CODE> and <CODE>tree_loop</CODE>
nodes in a procedure:

</P>

<PRE>
struct count_result {
    int num_fors;
    int num_loops;
};

void count_loops (tree_node *t, void *x)
{
    count_result *results = (count_result *)x;

    if (t-&#62;kind() == TREE_FOR) results-&#62;num_fors++; 
    else if (t-&#62;kind() == TREE_LOOP) results-&#62;num_loops++; 
}

/*
 *  Return the number of tree_fors and tree_loops in the procedure.
 */

void counter (tree_proc *p, int *for_count, int *loop_count)
{
    count_result results;
    results.num_fors = 0;
    results.num_loops = 0;

    p-&#62;map(count_loops, (void *)&#38;results);

    *for_count =  results.num_fors;
    *loop_count = results.num_loops;
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_20.html">previous</A>, <A HREF="suif1_22.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
